<!-- This document is based on the example document "index.html" of pivot.js. The derived parts are Copyright (c) 2012, Robert Jackson All rights reserved. and licensed under MIT as seen at https://github.com/rjackson/pivot.js. The added parts are
distributed under the conditions of CC BY-SA 4.0 International: https://creativecommons.org/licenses/by-sa/4.0/-->

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-us">
  <head>
    <meta charset="UTF-8">
    <meta name="msvalidate.01" content="99F28FCE87E260E62EC10F84BFD23866" />
    <title>LINMOBapps, a fork of MGLApps</title>
    <meta name="description" content="List of (potential) apps for mobile GNU/Linux">

    <link rel="stylesheet" href="./lib/css/pivot.css" type="text/css"/>
    <link rel="stylesheet" href="./lib/css/bulma.min.css" type="text/css"/>
    <link rel="stylesheet" href="./lib/css/responsive.semanticui.min.css" type="text/css"/>
    <link rel="stylesheet" href="./lib/css/bulma-accordion.min.css" type="text/css"/>
    <style type="text/css">
    <!--
    .navbox {
	/*position: absolute;*/
	margin-top: 0;
	width: 100%;
	color: #fff;
	background: #000;
	border: 0px solid #000;
	position: -webkit-sticky; /* Safari */
        position: sticky;
        top: 0;
	z-index: 1000;
       }
    .navbox ul {
	list-style-type: none;
	margin: 0;
	padding: 0;
	overflow: hidden;       
       }
    .navbox li {
	display: inline;
       } 
    .navbox ul li a, .navbox ul li a:link, .navbox ul li a:hover, .navbox ul li a:active, .navbox ul li a:visited {
	text-decoration: none;
	color: #fff;
	padding: 16px !important;
       }
    .navbox ul li a.linmob {
        background-color: #c0c0c0;
       }
    .navbox ul li a:hover, .navbox ul li a:active {
	border-bottom: 2px solid #fff;
	background-color: #444;
       }
    .row-label-fields label {
	padding: 2px 4px;
       }
    -->	
    </style>
    <script type="text/javascript" src="./lib/javascripts/jquery.js"></script>
    <script type="text/javascript" src="./lib/javascripts/jquery.dataTables.js"></script>
    <script type="text/javascript" src="./lib/javascripts/pivot.js"></script>
    <script type="text/javascript" src="./lib/javascripts/jquery_pivot.js"></script>
    <script type="text/javascript" src="./lib/javascripts/dataTables.responsive.min.js"></script>
    <script type="text/javascript" src="./lib/javascripts/linkify.min.js"></script>
    <script type="text/javascript" src="./lib/javascripts/linkify-string.min.js"></script>
    <script type="text/javascript" src="./lib/javascripts/bulma-accordion.min.js"></script>
  </head>
  <body class="hero">
<div class="navbox"><ul><li><a href="#apps">apps</a></li><li><a href="#frameworks">frameworks</a></li><li><a href="#fields">fields</a></li><li><a href="#contribute">contribute</a></li><li style="float:right;"><a href="https://linmob.net" target="_blank" class="linmob">linmob.net</a></li></ul></div>
<div class="hero-body">
      <h1 class="title is-1">LINMOBapps</h1>
      <h3 class="title is-3">LINux on MOBile App List</h3>
      <div class="content">
        <p>
	LINux on MOBile Apps (short: LINMOBapps) is a fork of the awesome <a href="https://mglapps.frama.io">Mobile GNU/Linux Apps (short: MGLApps) list</a>, which is a list of (potential) applications for usage on mobile devices running GNU/Linux, having small(er) screens and touch input (e.g. smartphones, tablets, convertibles). It has been forked with the intention of providing for faster merge times and adding more information on packaging. <em><a href="#contribute">See below how you can contribute!</a></em>
        </p>
	<p id="apps"> 
          Project repository: <a href="https://framagit.org/linmobapps/linmobapps.frama.io">https://framagit.org/linmobapps/linmobapps.frama.io</a>
        </p>
        <section class="accordions">
          <article class="accordion is-inactive">
            <div class="accordion-header toggle" style="background-color: lightgrey; color: black;">
              Adjust table
            </div>
            <div class="accordion-body">
              <div class="accordion-content">
                <h4>Filter Fields</h4>

                <ul class="stop-propagation">
                  <div id="filter-list"></div>
                </ul>
                <h4>Fields to display</h4>
                <ul class="stop-propagation" style="overflow:auto;max-height:450px;padding:10px;">
                  <div id="row-label-fields"></div>
                </ul>
                <span id="pivot-detail" class="content"></span>
              </div>
            </div>
          </div>
        <div id="results"></div>
        <script>
        document.getElementById("results").innerHTML="App list is loading...";
        </script>
        <noscript style="font-style: bold; background: red;">
        <p style="padding: 10px; font-style: bold; font-color: white; background: #3da;">JavaScript is required to view this table
        <br>
        <br>
        You can get the raw .csv table at <a target="_blank" href="https://linmobapps.frama.io/apps.csv">https://linmobapps.frama.io/apps.csv</a>
        <br>
        <br>
        All JavaScript code used in this site is free and open source software - the whole source code for this site can be found at <a href="https://framagit.org/linmobapps/linmobapps.frama.io">https://framagit.org/linmobapps/linmobapps.frama.io</a>
        </p>
        </noscript>
        <br>
        <div class="content">
          <a class="button" href="apps.csv">Get .csv</a>

          <h3 class="title is-3" id="frameworks">Compatible frameworks</h3>
          Apps built with following frameworks are usually compatible with mobile GNU/Linux devices:
          <ul>
            <li>
              <a href="https://doc.qt.io/qt-5/qtquick-index.html" target="_blank">Qt Quick</a>
            </li>
            <li>
              <a href="https://develop.kde.org/frameworks/kirigami/" target="_blank">Kirigami</a>
            </li>
            <li>
              <a href="https://mauikit.org" target="_blank">MauiKit</a>
            </li>
            <li>
              <a href="https://docs.liri.io/sdk/fluid/develop/" target="_blank">Fluid</a>
            </li>
            <li>
              <a href="https://gnome.pages.gitlab.gnome.org/libhandy/" target="_blank">libhandy</a>
            </li>
            <li>
              <a href="https://libgdx.badlogicgames.com" target="_blank">libGDX</a>
            </li>
          </ul>

          <h3 class="title is-3">Target audiences</h3>
          <ul>
            <li>Users with special regards on freedom, privacy and convergence, specifically users of the Pine64 PinePhone and the Purism Librem 5</li>
            <li>Packagers searching for apps to bundle with GNU/Linux-based mobile operating systems</li>
            <li>Contributors who want to help with programming, designing, documenting or in other ways</li>
          </ul>

          <h3 class="title is-3">Other lists</h3>
          <ul>
	    <li>
              <a href="https://mglapps.frama.io" target="_blank">MGL Apps List</a> (the origin of this list)
	    </li>
            <li>
              <a href="https://wiki.postmarketos.org/wiki/Potential_apps" target="_blank">postmarketOS Wiki: Potential_apps</a>
            </li>
            <li>
              <a href="https://wiki.mobian-project.org/doku.php?id=apps" target="_blank">Mobian Wiki: Apps</a> 
            </li>
            <li>
              <a href="https://phabricator.kde.org/T7771" target="_blank">https://phabricator.kde.org/T7771</a>
            </li>
            <li>
             <a href="https://tracker.pureos.net/w/pureos/mobile_optimized_apps/" target="_blank">PureOS: Mobile-optimized apps</a>
            </li>
            <li>
             <a href="https://tracker.pureos.net/w/pureos/3rd-party_mobile_optimized_apps/" target="_blank">PureOS: Mobile-optimized apps from 3rd party repos</a>
            </li>
              <li>
         <a href="https://source.puri.sm/Librem5/community-wiki/-/wikis/List-of-Apps-in-Development" target="_blank">Purism: List of Apps in Development</a>
             </li>
	    <li>
              <a href="https://source.puri.sm/Librem5/libhandy" target="_blank">https://source.puri.sm/Librem5/libhandy</a>
            </li>
            <li>
              <a href="https://source.puri.sm/Librem5/Apps_Issues" target="_blank">Purism: Librem5: Apps_Issues</a>
            </li>
            <li>
              <a href="https://wiki.ubuntuusers.de/Ubuntu_Touch/Programme" target="_blank">https://wiki.ubuntuusers.de/Ubuntu_Touch/Programme</a>
            </li>
            <li>
              <a href="https://sturmflut.github.io/ubuntu/touch/2015/05/31/ubuntu-touch-app-wishlist-may-2015/" target="_blank">https://sturmflut.github.io/ubuntu/touch/2015/05/31/ubuntu-touch-app-wishlist-may-2015/</a>
            </li>
           </ul>
          <h3 class="title is-3">App Stores/Listings:</h3>
          <ul>
            <li> 
              <a href="https://open-store.io/" target="_blank">Open Store: Ubuntu Touch Apps</a>
            </li>
            <li> 
              <a href="https://open-store.io/" target="_blank">Open Repos.net: Open Source Apps for Maemo, Harmattan, Sailfish OS, Nemo Mobile and PureOS</a>
            </li>
          </ul>

          <h3 class="title is-3"id="fields">Fields</h3>
          <ul>
<ul>
<li><b>name:</b> name of the app</li>
<li><b>category:</b> App category (one or two words)</li>
<li><b>summary:</b> one or two sentences about the app - normally a quote from the project site</li>
<li><b>mobile compatibility:</b> a number between 5 (best) and 0 (worst) to name the mobile compatibility of the app (this is different from MGLApps to be closer to the ratings in <a href="https://wiki.mobian-project.org/doku.php?id=apps">Mobian Wiki</a>; category 3 may be redefined, as it includes apps that apparently have not been tested on mobile  GNU/Linux or postmarketOS)<ul>
<li>5 = perfect - nothing left to be done </li>
<li>4 = almost perfect, works fine with tweaks for scaling, like `scale-to-fit´ on Phosh</li>
<li>3 = some parts of the app are not usable with touch input on small screens</li>
<li>2 = many parts of the app are not usable with touch input on small screens</li>
<li>1 = app is unusable with touch input on small screens – why is this app in the LINMOBapps app list?</li>
<li>A = mobile compatibility could be perfect because the app was ported to other mobile platforms (e.g. Android)</li>
</ul>
</li>
<li><b>repository:</b> link to the code repository</li>
<li><b>framework:</b> UI frameworks which are used by the app</li>
<li><b>screenshots:</b> links to sites providing screenshots of the application</li>
<li><b>website:</b> link to the project‘s website</li>
<li><b>license:</b> license of the project</li>
<li><b>appid:</b> AppStream ID in the form {tld}.{vendor}.{product} (e.g. org.kde.itinerary)</li>
<li><b>scale-to-fit:</b> AppID to scale the app properly in Phosh (with scale-to-fit AppID on)</li>
<li><b>flatpak:</b> link to the Flathub page (if available) or another location the app could be installed from as flatpak</li>
<li><b>aur:</b> name of the corresponding package build in the <a href="https://aur.archlinux.org" target="_blank">Arch User Repository</a></li>
<li><b>postmarketos:</b> name of the corresponding package in the postmarketOS/Alpine repositories <em>(definitely incomplete, contributions welcome!)</em></li>
<li><b>debian:</b> name of the corresponding debian package <em>(definitely incomplete, contributions welcome!)</em></li>
<li><b>notice:</b> additional information about develpment stage, mobile compatibility or what else is important to know</li>
<li><b>more information:</b> links to sites providing more information about the app</li>
<li><b>backend:</b> backends which are used by the app</li>
<li><b>service:</b> services the app includes and makes use of</li>
<li><b>description:</b> more detailed text about the app - normally a quote from the project site</li>
<li><b>description source:</b> if 'description' is a quote, this provides the source</li>
<li><b>summary source:</b> if 'summary' is a quote, this provides the source</li>
</ul>
          <h3 class="title is-3" id="contribute">Contribute</h3>
          Help making this collection of Apps better by your contribution!
	  <p>
          The data table is a simple .csv file. You can edit it with a common spreadsheet programm like LibreOffice Calc or Calligra Sheets.
          <br>
	  Project repository: <a href="https://framagit.org/linmobapps/linmobapps.frama.io">https://framagit.org/linmobapps/linmobapps.frama.io</a></p>
	  <p>
	    If you have additions or corrections, you can also send these in via <a href="mailto:applist@linmob.net?subject=Addition%20or%20Correction" target="_blank" rel="noopener">email</a>. For small fixes or to just inform about an app, you may also @ me on the fediverse &mdash; <a rel="me" href="https://fosstodon.org/@linmob">@linmob@fosstodon.org</a>. Please adjust the subject and try to provide as much information as you can, and also whether/how you want to be mentioned in the commit.
          </p>
          <p>
If you want to know what I am working on and want to help with it, check <a href="https://framagit.org/linmobapps/linmobapps.frama.io/-/blob/master/tasks.md">tasks.md</a>!
	  </p>
	  <p>
	  	If an app lacks features, or no apps exists for a particular service you need or want to use on your mobile Linux device, maybe Purism's <a href="https://puri.sm/fund-your-app/">Fund Your App</a> program can help you. (This is no endorsement, the developer story and the availability of the App Store these apps are likely being shipped with for non-Purism devices remains unclear currently.)
	  </p>
        </div>
      </div>
      <footer class="footer" style="padding-bottom: 3rem;">
        <div class="content has-text-centered">
          The LINMOBapps app list is, just like its origin, the MGLApps app list, licensed under
          <a href="https://creativecommons.org/licenses/by-sa/4.0/" target="_blank">CC BY-SA 4.0 International</a>
          <br>
          Built with ♥ and amazing free and open source software:
          <a href="http://rwjblue.github.io/pivot.js/" target="_blank">Pivot.js</a>,
          <a href="https://www.datatables.net/" target="_blank">Datatables</a>,
          <a href="https://soapbox.github.io/linkifyjs/" target="_blank">Linkify</a>,
          <a href="http://bulma.io/" target="_blank">Bulma</a>,
          <a href="https://wikiki.github.io" target="_blank">Bulma-Extensions</a>
          and
          <a href="https://jquery.com/" target="_blank">jQuery</a>
          <br>
          <br>
          I and the other contributors do not take any warranty for the correctness of any information on this page. If you want to be sure, please visit the mentioned sites and check the information.
          <br>
          The fields "summary" and "description" are quotations from the sites mentioned in the fields "summary source" and "description source"
        </footer>
      </div>
    </body>

<script type="text/javascript">

// Define the structure of fields, if this is not defined then all fields will be assumed
// to be strings.  Name must match csv header row (which must exist) in order to parse correctly.
fields =[{name: 'name', type: 'string', filterable: true, columnLabelable: true},
{name: 'repository', type: 'string', filterable: true},
{name: 'website', type: 'string', filterable: true},
{name: 'more information', type: 'string', filterable: true},
{name: 'license', type: 'string', filterable: true},
{name: 'category', type: 'string', filterable: true},
{name: 'summary', type: 'string', filterable: true},
{name: 'summary source', type: 'string', filterable: true},
{name: 'description', type: 'string', filterable: true},
{name: 'description source', type: 'string', filterable: true},
{name: 'screenshots', type: 'string', filterable: true},
{name: 'mobile compatibility', type: 'string', filterable: true},
{name: 'framework', type: 'string', filterable: true},
{name: 'backend', type: 'string', filterable: true},
{name: 'service', type: 'string', filterable: true},
{name: 'appid', type: 'string', filterable: true},
{name: 'scale-to-fit', type: 'string', filterable: true},
{name: 'notice', type: 'string', filterable: true},
{name: 'flatpak', type: 'string', filterable: true},
{name: 'aur', type: 'string', filterable: true},
{name: 'postmarketos', type: 'string', filterable: true},
{name: 'debian', type: 'string', filterable: true},
];

  function setupPivot(input) {
    input.callbacks = {
      afterUpdateResults: function () {
        $('#results > table').DataTable({responsive: true, paginate: false, scrollX: 500, class: "input", "sDom": "<'row'<'span6'l><'span6'f>>t<'row'<'span6'i><'span6'p>>"});
      }
    };
    $('#pivot-demo').pivot_display('setup', input);
  };

  $(document).ready(function () {
    $.ajax({
      url: "apps.csv",
      dataType: "text",
      success: function (data) {
        data = data.replace(/,/g, " ||| ");
        console.log(data);
        data = linkifyStr(data, {
          defaultProtocol: "https",
          format: function (value, type) {
            return value;
          }
        });
        data = data.replace(/ \|\|\| /g, ",");
        console.log(data);
        setupPivot({
          csv: data,
          fields: fields,
          rowLabels: [
            "name",
            "category",
            "summary",
            "mobile compatibility",
            "repository",
            "framework",
            "screenshots",
            "website",
            "license",
            "appid",
            "scale-to-fit",
            "flatpak",
            "aur",
            "postmarketos",
            "debian",
            "notice",
            "more information",
            "backend",
            "service",
            "description",
            "description source",
            "summary source"
          ]
        })

        $('.stop-propagation').click(function (event) {
          event.stopPropagation();
        });
        console.log(data);
      }
    });

    // $('#fieldExplanations').pivot_display('setup', {url:"fields.csv", fields: [{name: 'name', type: 'string', filterable: true, columnLabelable: true}, {name: 'explanation', type: 'string', filterable: true, columnLabelable: true}], rowLabels:["name",
    // "explanation"]});
    var accordions = bulmaAccordion.attach();
  });
</script>
